import {request} from './request';

export function account() {
    return request
        .get('/api/info')
        .timeout(30000)
        .end();
}

export function login(username, password) {
    return request
        .get('/api/authn/users/login')
        .auth(username, password)
        .timeout(30000)
        .end();
}

export function authenticate(username, apiKey) {
    return request
        .post(`/api/authn/users/${username}/authenticate`)
        .send(apiKey)
        .timeout(30000)
        .end();
}
