var React = require('react'),
    Fluxxor = require('fluxxor');

var FluxMixin = Fluxxor.FluxMixin(React),
    StoreWatchMixin = Fluxxor.StoreWatchMixin;

var AuditTable = require('../audit/table'),
    FoldableAuditSection = require('../generic/foldable_audit_section');

var Activity = require('./activity');

export default React.createClass({
    displayName: 'Dashboard',

    mixins: [FluxMixin, StoreWatchMixin('audit')],

    getStateFromFlux() {
        var audit = this.getFlux().store('audit').getAllEvents();

        return {
            audit: audit.data,
            loading: audit.loading
        };
    },

    render() {
        return (
          <div className="b-dashboard">
            <Activity audit={this.state.audit}
                      isLoading={this.state.loading} />
            <hr />
            {FoldableAuditSection.warnings(this.state.audit, this.state.loading)}
            <hr />
            {FoldableAuditSection.changes(this.state.audit, this.state.loading)}
            <hr />
            <AuditTable events={this.state.audit}
                        caption="Recent activity"
                        isLoading={this.state.loading} />
          </div>
        );
    },

    componentDidMount() {
        this.getFlux().actions.audit.loadAll();
    }
});
