import React from 'react';
import {FluxMixin, StoreWatchMixin} from 'fluxxor';
import _ from 'lodash';

import './flash.less';

export default React.createClass({
    displayName: 'Flash',

    mixins: [FluxMixin(React), StoreWatchMixin('app')],

    getInitialState() {
        return {
            hover: false
        };
    },

    getStateFromFlux() {
        return this.getFlux().store('app').getState();
    },

    handleClose() {
        this.getFlux().actions.flashMessageClear();
    },

    onMouseOver() {
        this.setState({
            hover: true
        });
    },

    onMouseOut() {
        this.setState({
            hover: false
        });
    },

    setTimeout() {
        this.clearTimeout();
        this.timeout = window.setTimeout(this.handleClose, 10000);
    },

    clearTimeout() {
        window.clearTimeout(this.timeout);
    },

    shouldComponentUpdate(nextProps, nextState) {
        let shouldUpdate = false,
            msgsWasAdded = false;

        if (nextState.flashMsgs.length === 0) {
            this.clearTimeout();
            shouldUpdate = true;
        }

        if (nextState.flashMsgs.length > this.state.flashMsgs.length) {
            shouldUpdate = true;
            msgsWasAdded = true;
        }

        if (nextState.hover === true) {
            this.clearTimeout();
        }

        if ((nextState.hover === false && this.state.hover === true) ||
            msgsWasAdded) {
            this.setTimeout();
        }

        return shouldUpdate;
    },

    componentWillUnmount() {
        window.clearTimeout(this.timeout);
    },

    render() {
        let msgs = _.chain(this.state.flashMsgs)
                .pluck('msg')
                .map((msg) => {
                    return <div className="text" key={_.escape(msg)}>{msg}</div>;
                })
                .value();

        if (msgs.length > 0) {
            return (
              <div className="alert alert-danger alert-dismissable"
                   onMouseOver={this.onMouseOver} onMouseOut={this.onMouseOut}>
                <button type="button" className="close" aria-hidden="true"
                        onClick={this.handleClose}>×</button>
                    {msgs}
              </div>
            );
        } else {
            return null;
        }
    }
});
