var React = require('react');

import {map} from 'lodash';

var Breadcrumb = React.createClass({
    displayName: 'Breadcrumb',

    render() {
        var className = '',
            text;

        if (this.props.active === true) {
            className = 'active';
            text = this.props.text;

        } else if (this.props.extra === true) {
            className = 'b-breadcrumb__extra';
            text = this.props.text;
        } else {
            text = (<a href={this.props.url}>{this.props.text}</a>);
        }

        return (
          <li className={className}>
            {text}
          </li>
        );
    }
});

export default React.createClass({
    displayName: 'Breadcrumbs',

    render() {
        var items = map(this.props.elems || [], function(e, idx, coll) {
            var length = coll.length - 1,
                active = idx + 1 === length ? true : false,
                extra = idx === length ? true : false;

            return (
              <Breadcrumb url={e.url}
                          text={e.text}
                          active={active}
                          extra={extra}
                          key={e.url + e.text} />
            );
        });

        return (
          <div className="b-breadcrumbs">
            <ol className="breadcrumb">
              {items}
            </ol>
          </div>
        );
    }
});
