var React = require('react'),
    Link = require('react-router').Link;

import {sortBy, values} from 'lodash';

var RoleLink = require('./role_link');

var CustomTypeListItem = React.createClass({
    displayName: 'CustomTypeListItem',

    render() {
        var kind = window.encodeURIComponent(this.props.data.record.kind),
            id = window.encodeURIComponent(this.props.data.record.identifier),
            label = this.props.data.record.kind + ':' + this.props.data.record.identifier;

        return (
          <tr>
            <td className="id">
              <Link to={this.props.data.kind}
                    params={{kind: kind, id: id}}>
                {label}
              </Link>
            </td>
            <td className="ownerId">
              <RoleLink id={this.props.data.record.ownerid || this.props.data.record.owner} />
            </td>
          </tr>
        );
    }
});

var GenericListItem = React.createClass({
    displayName: 'GenericListItem',

    render() {
        return (
          <tr>
            <td className="id">
              <Link to={this.props.data.kind}
                    params={{id: window.encodeURIComponent(this.props.data.record.identifier)}}>
                {this.props.data.record.identifier}
              </Link>
            </td>
            <td className="ownerId">
              <RoleLink id={this.props.data.record.ownerid || this.props.data.record.owner} />
            </td>
          </tr>
        );
    }
});

export default React.createClass({
    displayName: 'GenericList',

    getInitialState() {
        return {
            sort: {
                column: this.props.defaultColumn || 'id',
                order: this.props.defaultOrder || 'asc'
            },
            columns: this.props.columns || {
                id: {
                    id: 'id',
                    name: 'Id',
                    defaultSortOrder: 'desc'
                },
                owner: {
                    id: 'owner',
                    name: 'Owner',
                    defaultSortOrder: 'desc'
                }
            }
        };
    },

    sortColumn(column) {
        return function(e) {
            e.preventDefault();

            var order = (this.state.sort.order === 'asc') ? 'desc' : 'asc';

            if (this.state.sort.column !== column) {
                order = this.state.columns[column].defaultSortOrder;
            }

            this.setState({sort: {column: column, order: order}});
        }.bind(this);
    },

    sortClass(column) {
        var order = (this.state.sort.order === 'asc') ?
                'glyphicon glyphicon-chevron-up' : 'glyphicon glyphicon-chevron-down';

        return (this.state.sort.column === column) ? order : '';
    },

    render() {
        var items = this.props.data.members.map(function(o) {
            return o;
        });

        items = sortBy(items, this.state.sort.column);

        if (this.state.sort.order === 'desc') {
            items.reverse();
        }

        var rows = items.map(function(o) {
            if (this.props.data.kind === 'custom-type') {
                return (
                  <CustomTypeListItem data={{kind: this.props.data.kind, record: o}} key={o.id} />
                );
            }

            return (
              <GenericListItem data={{kind: this.props.data.kind, record: o}} key={o.id} />
            );
        }.bind(this));

        var columns = values(this.state.columns).map(function(c) {
            return (
              <th onClick={this.sortColumn(c.id)} key={c.id} >
                {c.name}<span className={'header ' + this.sortClass(c.id)} />
              </th>
            );
        }, this);

        return (
          <table className={this.props.data.kind + 'List'}>
            <thead>
              <tr>
                {columns}
              </tr>
            </thead>
            <tbody>
              {rows}
            </tbody>
          </table>
        );
    }
});
