var React = require('react'),
    Fluxxor = require('fluxxor');

var FluxMixin = Fluxxor.FluxMixin(React),
    StoreWatchMixin = Fluxxor.StoreWatchMixin;

var GenericList = require('./list'),
    Refresh = require('../refresh/refresh');

export default function listFactory(kind, title) {
    return React.createClass({
        displayName: title + 'List',

        mixins: [FluxMixin, StoreWatchMixin('resources')],

        getStateFromFlux() {
            var resources = this.getFlux().store('resources').getResources(kind);

            return {
                loading: resources.loading,
                error: resources.error,
                resources: resources.data
            };
        },

        render() {
            return (
              <div className="variableBox">
                <div className="variableList">
                  <h2>{title}<Refresh show={this.state.loading} /></h2>
                  <GenericList data={{kind: kind, members: this.state.resources}} />
                </div>
              </div>
            );
        },

        componentDidMount() {
            this.getFlux().actions.resources.load(kind);
        }
    });
}
