/* global jest, describe, it, expect */
"use strict";

jest.dontMock('collections/set');
jest.dontMock('../helpers');

var {nextId} = require('../helpers').__test__;
var Set = require('collections/set');

describe('nextId', ()=> {
    it('generates unique ids', ()=> {
        var s = new Set();
        for (let i = 0; i < 100; i++) {
            s.add(nextId());
        }
        expect(s.length).toBe(100);
    });

    it('returns strings when no prefix is given', ()=>{
        expect(typeof nextId()).toBe('string');
    });

    it('uses a prefix if given', ()=>{
        expect(nextId('hello').indexOf('hello')).toBe(0);
    });

});