/* global jest, describe, it, expect */
"use strict";

jest.dontMock('../helpers');

var {roleKindFromId} = require('../helpers').__test__;

describe('roleKindFromId', () =>{
    it('parses an id with 3 components correctly', () =>{
        expect(roleKindFromId('companyname:user:bob')).toBe('user');
    });

    it('parses an id with more than three components correctly', ()=>{
       expect(roleKindFromId('a:b:c:d')).toBe('b');
    });

    it('parses an id with 2 components correctly', ()=>{
        expect(roleKindFromId('user:bob')).toBe('user');
    });

    it('returns the id unchanged when it has a single component', () =>{
        expect(roleKindFromId('asdf')).toBe('asdf');
    });
});