var React = require('react'),
    Fluxxor = require('fluxxor');

import {DropdownButton, Navbar, Nav, MenuItem} from 'react-bootstrap';
import {SplitButton, Button} from 'react-bootstrap';

var NavItemLink = require('react-router-bootstrap/lib/NavItemLink'),
    MenuItemLink = require('react-router-bootstrap/lib/MenuItemLink');

var NavSearchForm = require('./nav_search_form');

var FluxMixin = Fluxxor.FluxMixin(React);

export default React.createClass({
    displayName: 'Navbar',

    mixins: [FluxMixin],

    contextTypes: {
        router: React.PropTypes.func
    },

    handleClick(e) {
        e.preventDefault();

        this.context.router.transitionTo('user', {id: this.props.username});
    },

    render() {
        const style = {marginTop: '8px'},
              listStyle = {marginRight: '15px'};

        var button = (
            <Button title={`user ${this.props.username}`}
                    style={style}
                    onClick={this.handleClick}>
                {`user ${this.props.username}`}
            </Button>
        );

        if (this.getFlux().actions.getRManager().allowLogout) {
            button = (
                <SplitButton title={`user ${this.props.username}`}
                             style={style}
                             onClick={this.handleClick}>
                    <MenuItemLink to="logout">
                        Logout
                    </MenuItemLink>
                </SplitButton>
            );
        }

        return (
          <Navbar brand="Conjur">
            <Nav eventKey={0}>
              <NavItemLink to="dashboard">
                Dashboard
              </NavItemLink>
              <DropdownButton eventKey={3} title="Directory">
                <MenuItemLink to="users">
                  Users
                </MenuItemLink>
                <MenuItemLink to="groups">
                  Groups
                </MenuItemLink>
                <MenuItem divider={true} />
                <MenuItemLink to="hosts">
                  Hosts
                </MenuItemLink>
                <MenuItemLink to="layers">
                  Layers
                </MenuItemLink>
                <MenuItem divider={true} />
                <MenuItemLink to="variables">
                  Variables
                </MenuItemLink>
                <MenuItemLink to="custom-types">
                  Custom Types
                </MenuItemLink>
              </DropdownButton>
              <NavItemLink to="policies">
                Policies
              </NavItemLink>
            </Nav>
            <Nav right={true} eventKey={1} style={listStyle}>
                <li>
                    {button}
                </li>
              <li>
                <NavSearchForm />
              </li>
            </Nav>
          </Navbar>
        );
    }
});
