var React = require('react');

import {pluralize} from '../../utils';
import {intersection, uniq, capitalize} from 'lodash';

var ResourceLink = require('../generic/resource_link');

var knownTypes = ['user', 'group', 'layer', 'host', 'variable', 'policy'];

export default React.createClass({
    displayName: 'OwnedResourcesBox',

    getInitialState() {
        return {
            filter: ''
        };
    },

    handleChange(e) {
        e.preventDefault();

        this.setState({filter: e.target.value});
    },

    render() {
        var filters = [];

        if (!this.props.resources) {
            return (
              <span>None</span>
            );
        }

        var items = this.props.resources
                .sort(function(a, b) {
                    // TODO: sort by kind with custom weights, by id, by creation date
                    // automatically gives sort by kind, id
                    return a.id.toLowerCase().localeCompare(b.id.toLowerCase());
                }).map(function(resource) {
                    var kind = resource.id.split(':')[1];

                    filters.push(kind);

                    if ((this.state.filter === '') ||
                        (this.state.filter !== 'other' && this.state.filter === kind) ||
                        (this.state.filter === 'other' &&
                         intersection([kind], knownTypes).length === 0)) {

                        return (
                          <li className="list-group-item list-group-item-noborder">
                            <ResourceLink id={resource.id} />
                          </li>
                        );
                    }

                    return '';
                }.bind(this));

        var toggleButton = '';

        if (!this.props.tabview) {
            toggleButton = (
              <div className="hide-all">
                <a onClick={this.props.handler}>Hide all &laquo;</a>
              </div>
            );
        }

        var filterSelect = '';

        if (this.props.resources.length > 9 || this.state.filter !== '') {
            // TODO: sort, when done with previous TODO
            filterSelect = intersection(uniq(filters, true), knownTypes).map(function(f) {
                return (
                    <option value={f}>{capitalize(pluralize(f))}</option>
                );
            });

            filterSelect = (
              <div className="form-group row">
                <div className="col-xs-3">
                  <select className="form-control" type="select" ref="filter"
                          value={this.state.filter} onChange={this.handleChange}>
                    <option value="">Show all</option>
                    {filterSelect}
                    <option value="other">Other</option>
                  </select>
                </div>
              </div>
            );
        }

        return (
          <div className="owned">
            {toggleButton}
            {filterSelect}
            <ul className="list-group">{items}</ul>
          </div>
        );
    }
});
