var React = require('react');

var SearchGroupHeading = require('./group_heading'),
    SearchResultItem = require('./result_item');

export default React.createClass({
    displayName: 'SearchGroup',

    propTypes: {
        kind: React.PropTypes.string,
        items: React.PropTypes.array
    },

    getDefaultProps() {
        return {
            kind: '',
            items: []
        };
    },

    render() {
        var id = 'search-group-' + this.props.kind;

        var items = this.props.items.map(function(r) {
            return (
              <SearchResultItem data={r}/>
            );
        });

        return (
          <div id={id} className="panel panel-default search-group">
            <SearchGroupHeading kind={this.props.kind}
                                items={this.props.items} />
            <div id={'search-collapse-' + this.props.kind}
                 className="panel-collapse collapse in">
              <div className="panel-body">
                {items}
              </div>
            </div>
          </div>
        );
    }
});
