var React = require('react');

import {capitalize} from 'lodash';

var SearchGroupTitle = require('./group_title');

import {pluralize} from '../../utils';

export default React.createClass({
    displayName: 'SearchGroupHeading',

    propTypes: {
        kind: React.PropTypes.string,
        items: React.PropTypes.array
    },

    getDefaultProps() {
        return {
            kind: '',
            items: []
        };
    },

    render() {
        var targetId = '#search-collapse-' + this.props.kind;

        return (
          <div className="panel-heading">
            <h4 className="panel-title">
              <a data-toggle="collapse"
                 data-target={targetId}
                 className={'group-heading' + this.props.kind}>
                <SearchGroupTitle kind={this.props.kind}
                                  items={this.props.items} />
              </a>
            </h4>
          </div>
        );
    },

    title() {
        var words = this.props.kind.replace(/[-_]/, ' ').split(' ');

        words[words.length - 1] = pluralize(words[words.length - 1]);

        return (
            words.map(capitalize).join(' ') + ' (' + this.props.items.length + ')'
        );
    }
});
