var React = require('react');

require('./pubkeys.less');

var PubkeyItem = React.createClass({
    displayName: 'PubkeyItem',

    render: function() {
        return (
          <div className="b-pubkey">
            <div className="b-pubkey__logo">
              <span className="badge">{this.props.pubkey[0]}</span>
            </div>
            <ul className="b-pubkey__list list-unstyled">
              <li className="b-pubkey__name">
                {this.props.pubkey[2]}
              </li>
              <li className="b-pubkey__fingerprint">
                {/* TODO: key fingerprint */}
              </li>
              <li className="b-pubkey__info">
                {/* TODO: When added, when last time used */}
              </li>
            </ul>
            <div className="b-pubkeys__actions">
              {/* TODO: Action buttons */}
            </div>
          </div>
        );
    }
});

var PubkeysHelp = React.createClass({
    displayName: 'PubkeysHelp',

    render: function() {
        var ret;

        if (React.Children.count(this.props.children) > 0) {
            ret = (
              <p className="b-pubkeys__help">
                {this.props.children}
              </p>
            );
        } else {
            var login = this.props.login;

            ret = (
              <p className="b-pubkeys__help">
                There are no pubkeys registered for this user yet.
                Use following command to upload one from a file:
                <pre>$ conjur pubkeys add {login} @userkeyfile.pub</pre>
              </p>
            );
        }

        return ret;
    }
});

var PubkeysList = React.createClass({
    displayName: 'PubkeysList',

    render: function() {
        var login = this.props.login;

        var pubkeysList = this.props.pubkeys.map(function(k, idx, coll) {
            var tokens = k.split(' ');

            var className = 'b-pubkeys__item list-group-item list-group-item-noborder';

            if (idx + 1 !== coll.length) {
                className += ' b-pubkeys__item--headline';
            }

            return (
              <li className={className}>
                <PubkeyItem pubkey={tokens} />
              </li>
            );
        });

        return (
          <div className="b-pubkeys">
            <PubkeysHelp>
              This is list of SSH public keys associated with user {login}.
            </PubkeysHelp>
            <ul className="b-pubkeys__list">
              {pubkeysList}
            </ul>
          </div>
        );
    }
});

export default React.createClass({
    render: function() {
        var body;

        if (this.props.isLoading) {
            body = (
              <p>Loading...</p>
            );
        } else if (this.props.pubkeys.length > 0) {
            body = (
              <PubkeysList login={this.props.login} pubkeys={this.props.pubkeys} />
            );
        } else {
            body = (
              <div className="b-pubkeys">
                <PubkeysHelp login={this.props.login} />
              </div>
            );
        }

        return body;
    }
});
