var React = require('react');

var Chart = require('../chart/chart'),
    ChartHelperMixin = require('../chart/chart_helper_mixin'),
    Refresh = require('../refresh/refresh');

export default React.createClass({
    displayName: 'VariableActivity',

    mixins: [ChartHelperMixin],

    propTypes: {
        audit: React.PropTypes.array,
        isLoading: React.PropTypes.bool
    },

    getDefaultProps() {
        return {
            audit: [],
            isLoading: false,
            options: {
                legend: {
                    sread: 'Successful reads',
                    supdate: 'Successful updates',
                    fread: 'Failed reads',
                    fupdate: 'Failed updates'
                },
                axis: {
                    y: {
                        label: 'Value'
                    }
                }
            }
        };
    },

    getDefaultItem() {
        return {
            sread: 0,
            supdate: 0,
            fread: 0,
            fupdate: 0
        };
    },

    getEventType(e) {
        if (e.action === 'check') {
            if (e.hasOwnProperty('error') || e.allowed === false) {
                if (e.privilege === 'execute') {
                    return 'fread';
                } else if (e.privilege === 'update') {
                    return 'fupdate';
                }
            }

            if (!e.hasOwnProperty('error') && e.allowed !== false) {
                if (e.privilege === 'execute') {
                    return 'sread';
                } else if (e.privilege === 'update') {
                    return 'supdate';
                }
            }
        }

        return null;
    },

    getInitialState() {
        return {showActivity: false};
    },

    toggleActivity(e) {
        e.preventDefault();

        this.setState({showActivity: !this.state.showActivity});
    },

    render() {
        var data = this.getData(this.props.audit);
        var activityBody = [];

        var msg = this.state.showActivity ? 'Hide' : 'Show graph';

        if (this.state.showActivity) {
            activityBody.push(
                <div className="b-variable-activity__graph">
                  <Chart options={this.props.options}
                         data={data} />
                </div>
            );
        }

        return (
          <div className="b-variable-activity">
            <h2>Activity<Refresh show={this.props.isLoading} /></h2>
            <a href="#" onClick={this.toggleActivity}>{msg}</a>
            {activityBody}
          </div>
        );
    }
});
