var React = require('react');

var RoleLink = require('../generic/role_link'),
    Refresh = require('../refresh/refresh');

export default React.createClass({
    displayName: 'VariableDetails',

    propTypes: {
        variable: React.PropTypes.object,
        owner: React.PropTypes.string,
        isLoading: React.PropTypes.bool
    },

    getDefaultProps() {
        return {
            variable: {},
            owner: '',
            isLoading: false
        };
    },

    render() {
        return (
          <div className="b-variable-details">
            <h2>Details<Refresh show={this.props.isLoading} /></h2>
            <dl className="dl-horizontal">
              <dt>Owner</dt>
              <dd><RoleLink id={this.props.owner} /></dd>

              <dt>Created by</dt>
              <dd><RoleLink id={this.props.variable.userid} /></dd>

              <dt>MIME type</dt>
              <dd>{this.props.variable.mime_type}</dd>

              <dt>Kind</dt>
              <dd>{this.props.variable.kind}</dd>

              <dt>Versions</dt>
              <dd>{this.props.variable.version_count}</dd>
            </dl>
          </div>
        );
    }
});
