import {createStore} from 'fluxxor';
import _ from 'lodash';
import constants from '../constants';

export default createStore({
    initialize() {
        this.flashMsgs = [];

        this.bindActions(
            constants.FLASH_MESSAGE, this.onFlashMessage,
            constants.FLASH_MESSAGE_CLEAR, this.onFlashMessageClear
        );
    },

    onFlashMessage(payload) {
        this.flashMsgs.push({
            msg: payload.msg,
            status: payload.status
        });

        this.emit('change');
    },

    onFlashMessageClear() {
        this.flashMsgs = [];

        this.emit('change');
    },

    getState() {
        return {
            flashMsgs: _.clone(this.flashMsgs, true)
        };
    }
});
