export function pluralize(kind) {
    if (kind[kind.length-1] === 'y') {
        return kind.slice(0, kind.length-1) + 'ies';
    } else if (kind[kind.length - 1] !== 's') {
        return kind + 's';
    } else {
        return kind;
    }
}

// http://www.quirksmode.org/js/cookies.html
export function readCookie(name) {
    const nameEQ = name + '=',
          ca = document.cookie.split(';');

    for (let i = 0; i < ca.length; i++) {
        let c = ca[i];

        while (c.charAt(0) === ' ') {
            c = c.substring(1, c.length);
        }

        if (c.indexOf(nameEQ) === 0) {
            return window.decodeURIComponent(
                c.substring(nameEQ.length, c.length));
        }
    }

    return null;
}

export function getTabname(header, set) {
    if (!set || !set.length) {
        return `${header} (0)`;
    }

    return `${header} (${set.length})`;
}
