require 'time'
require 'rack/utils'
require 'rack/mime'

require 'conjur/webserver/renderer'

module Conjur
  module WebServer
    class Home
      def initialize(root)
        @root = root
      end

      # From Rack::File
      def call(env)
        path = File.expand_path(INDEX, @root)
        renderer = Renderer.new @root

        page = File.read(path)
        files = [path]

        last_modified = files.map(&File.method(:mtime)).max.httpdate

        return [304, {}, []] if env['HTTP_IF_MODIFIED_SINCE'] == last_modified

        size = Rack::Utils.bytesize(page)

        headers = {
          "Last-Modified"  => last_modified,
          "Content-Type"   => "text/html",
          "Content-Length" => size.to_s
        }

        [200, headers, env["REQUEST_METHOD"] == "HEAD" ? [] : [page]]
      end

      private

      INDEX = 'index.html'.freeze
    end
  end
end
